#include "chess.h"
#include "data.h"
#include "weights.h"

void cBOARD::eval_pieces(){
    int r, f, i, s, sq, p, d, x, t, z;
	unsigned int m;
    int queen_out, oks, rks;
    int up_attack[2] = {0,0};
    int enprise[2] = {0,0};
	int pawncolor[2][2] = {0,0,0,0};
	int bishcolor[2][2] = {0,0,0,0};

	hits[WHITE] = 0;
	hits[BLACK] = 0;

    s = xside;
    do{
        queen_out = 0;
		oks = pieces[s^1][KING]+128; // p[WHITE] = sum of WHITE's to BLACK's king
		rks = pieces[s][KING]+128; // 'r' king
		m = mask[s] & 0x00010001;

        i=0;  
        do{
            if((sq = pieces[s][i]) & 0x88);
            else{
                p = square[sq].ptype;
                switch(p){
                case KING:
                    //advantage[s] += pcsq[p][s][sq] * kings2war;
                    //*fork
                    d = control[sq];
                    if(d & mask[s]){ // in check
                        enprise[s]=1;  // na
                        up_attack[s]++;
                        largest[s] = 10;
                    }
                    //*/
                break;
                case QUEEN:
                    advantage[s] += pcsq[p][s][sq];// * 5;
                    if(control[sq]&attack_mask[s][ROOK]) advantage[s] += rook_connected;
                    r = sq >> 4;
                    f = (sq & 7) + 1;
					t = 1;
					d = 0;
					do{
						x = sq;
						z = 0;
						while(((x += delta[d]) & OFFBOARD) == 0){
							if(control[x] & m){
								hits[s] += 3;
								t = 0;
								break;
							}
							if(z) break;
							if(square[x].ptype == PAWN) z = 1;
						}
						if(d == 7) break;
						d++;
					}while(t);

                    queen_out |= (int)((s==WHITE)? (r<6) : (r>1));
                    proximity[s] += proxim_val[manhattan[oks-sq]]<<1;
					defenders[s] += proxim_val[manhattan[rks-sq]];
                    //*fork
                    //if(!enprise[xside]){
                        d = control[sq];
                        if(d & mask[s]) do{ // attacked
                            enprise[s]=1;
                            if(d & mask[s^1]){ // defended
                                if(d & attack_mask[s^1][PAWN]) x = 8; // attacked by pawn
                                else if(d & minor_attack[s^1]) x = 6; // minor
                                else if(d & attack_mask[s^1][ROOK]) x = 4; // by rook
                                else break; // queen
                            }else x = 9;
                            up_attack[s]++;
							if(x > largest[s]){
								smallest[s] = largest[s];
								largest[s] = x;
							}else if(x > smallest[s]) smallest[s] = x;
                        }while(0);
                    //}    
                    //*/
					
                break;
                case ROOK:
                    advantage[s] += pcsq[p][s][sq];// * 4;
                    proximity[s] += proxim_val[manhattan[oks-sq]];
					defenders[s] += proxim_val[manhattan[rks-sq]];
					
					t = 1;
					d = 4;
					do{
						x = sq;
						z = 0;
						while(((x += delta[d]) & OFFBOARD) == 0){
							if(control[x] & m){
								hits[s] += 2;
								t = 0;
								break;
							}
							if(z) break;
							if(square[x].ptype == PAWN) z = 1;
						}
						if(d == 7) break;
						d++;
					}while(t);

					//*
                    if(control[sq]&attack_mask[s][ROOK]) advantage[s] += rook_connected;
                    //else{
                        f = 4;
                        r = rook_restricted;
                        do{
                            if((d = sq + delta[f]) & 0x88);//border[d]!=2 && 
                            else if(square[d].isempty()) {r = 0; break;}
							f += 2;
                        }while(f < 8);
                        liability[s] += r;
                    //}
                    //*/
                    
					//undeveloped[s] += (piece_home[s][sq] == p);
                    f = (sq & 7) + 1;
                    r = sq >> 4;
                    if(s == WHITE){
                        if(r < 2){							//975+1000+1300+800 = 
							liability[BLACK] += rook_on_7th;// * material[s] / 4075;
						}
                        //lat_onfile[s][f] += (r <= most_adv_pawn[WHITE][f]);// || most_adv_pawn[WHITE][f] < 4);
						if(least_adv_pawn[s][f] == 0){//< 4 && most_adv_pawn[BLACK][f] < 4){ // ie past 4th or gone
                            if(least_adv_pawn[BLACK][f] == 7){ // and opponents pawn is gone
                                liability[s] -= rook_on_open;
                            }else liability[s] -= rook_on_hopen;
                        }else{
                            t = rook_trap[pieces[s][KING]];
                            t >>= 1;//t & (t >> 1);
                            liability[s] += ((t & rook_trap[sq])>0) * rook_trapped;
                        }//*/   
                    }else{
                        if(r > 5){
							liability[WHITE] += rook_on_7th;// * material[s] / 4075;
						}
						//lat_onfile[s][f] += (r >= most_adv_pawn[BLACK][f]);// || most_adv_pawn[BLACK][f] > 3);
						if(least_adv_pawn[s][f] == 7){//> 3 && most_adv_pawn[WHITE][f] > 3){
                            if(least_adv_pawn[WHITE][f] == 0){
                                liability[s] -= rook_on_open;
                            }else liability[s] -= rook_on_hopen;
                        }else{
                            t = rook_trap[pieces[s][KING]];
                            t >>= 1; //t & (t >> 1);
                            liability[s] += ((t & rook_trap[sq])>0) * rook_trapped;
                        }//*/
                    }

                    //*fork
                    //if(!enprise[xside]){
                        d = control[sq];
                        if(d & mask[s]) do{ // attacked
                            enprise[s]=1;
                            if(d & mask[s^1]){ // defended
                                if(d & attack_mask[s^1][PAWN]) x = 4; // attacked by pawn
                                else if(d & minor_attack[s^1]) x = 2; // minor
                                else break; // major
                            }else x = 5;
                            up_attack[s]++;
                            if(x > largest[s]){
								smallest[s] = largest[s];
								largest[s] = x;
							}else if(x > smallest[s]) smallest[s] = x;
                        }while(0);
                    //}    
                    //*/
                break;
                case BISHOP:
					if(f=bishop_trap[s][sq])
						if(square[f].ptype == PAWN && square[f].color == (s^1))
							liability[s] += bishop_trapped * ((control[f]&mask[s])>0);

					advantage[s] += pcsq[p][s][sq];
                    undeveloped[s] += piece_home[s][sq];
                    proximity[s] += proxim_val[manhattan[oks-sq]];
					
					t = 1;
					d = 0;
					do{
						x = sq;
						z = 0;
						while(((x += delta[d]) & OFFBOARD) == 0){
							if(control[x] & m){
								hits[s]++;
								t = 0;
								break;
							}
							if(z) break;
							if(square[x].ptype == PAWN) z = 1;
						}
						if(d == 3) break;
						d++;
					}while(t);
					
					defenders[s] += proxim_val[manhattan[rks-sq]];
					//*
                    f = 0;
                    r = bishop_restricted;
                    do{
                        if((d = sq + delta[f]) & 0x88);
                        else if(border[d]<2 && square[d].ptype != PAWN) {r = 0; break;}
                    }while(++f < 4);
                    liability[s] += r;
                    //*/
                    //*
                    r = sq >> 4;
                    f = (sq & 7);
                    bishcolor[s][(f^r)&1]++;
                        
					if(outpost[s][sq]){
                        f++;
						if(s == WHITE){ // white bishop on outpost square
                            if(r <= least_adv_pawn[BLACK][f-1] && r <= least_adv_pawn[BLACK][f+1]){
                                liability[BLACK] += outpost[s][sq];
                                if(control[sq] & attack_mask[WHITE][PAWN])
                                    liability[BLACK] += outpost[s][sq]/2;
                            }
                        }else{//s == BLACK
                            if(r >= least_adv_pawn[WHITE][f-1] && r >= least_adv_pawn[WHITE][f+1]){
                                liability[WHITE] += outpost[s][sq];
                                if(control[sq] & attack_mask[BLACK][PAWN])
                                    liability[WHITE] += outpost[s][sq]/2;
                            }
                        }
                    }//*/
                    //*fork
                    //if(!enprise[xside]){
                        d = control[sq];
                        if(d & mask[s]) do{ // attacked
                            enprise[s]=1;
                            if(d & mask[s^1]){ // defended
                                if(d & attack_mask[s^1][PAWN]) x = 2; // attacked by pawn
                                else break; // minor | major
                            }else x = 3;
                            up_attack[s]++;
                            if(x > largest[s]){
								smallest[s] = largest[s];
								largest[s] = x;
							}else if(x > smallest[s]) smallest[s] = x;
                        }while(0);
                    //}    
                    //*/
                break;
                case KNIGHT:
                    advantage[s] += pcsq[p][s][sq];
                    undeveloped[s] += piece_home[s][sq];
					t = proxim_val[manhattan[oks-sq]];
					hits[s] += (int)(t==4);
                    proximity[s] += t;
					defenders[s] += proxim_val[manhattan[rks-sq]];
                    //*
                    if(outpost[s][sq]){
                        r = sq >> 4;
                        f = (sq & 7) + 1;
                        if(s == WHITE){
                            if(r <= least_adv_pawn[BLACK][f-1] && r <= least_adv_pawn[BLACK][f+1]){
                                liability[BLACK] += outpost[s][sq];
                                if(control[sq] & attack_mask[WHITE][PAWN])
                                    liability[BLACK] += outpost[s][sq]/2;
                            }
                        }else{//s == BLACK
                            if(r >= least_adv_pawn[WHITE][f-1] && r >= least_adv_pawn[WHITE][f+1]){
                                liability[WHITE] += outpost[s][sq];
                                if(control[sq] & attack_mask[BLACK][PAWN])
                                    liability[WHITE] += outpost[s][sq]/2;
                            }
                        }
                    }//*/
                    //*fork
                    //if(!enprise[xside]){
                        d = control[sq];
                        if(d & mask[s]) do{ // attacked
                            enprise[s]=1;
                            if(d & mask[s^1]){ // defended
                                if(d & attack_mask[s^1][PAWN]) x = 2; // attacked by pawn
                                else break; // minor | major
                            }else x = 3;
                            up_attack[s]++;
                            if(x > largest[s]){
								smallest[s] = largest[s];
								largest[s] = x;
							}else if(x > smallest[s]) smallest[s] = x;
                        }while(0);
                    //}    
                    //*/
                break;
                case PAWN:
                    r = sq >> 4;
                    f = (sq & 7);
                    pawncolor[s][(f^r)&1] += center[sq];
					//advantage[s] += pcsq[p][s][sq];
                    //liability[s^1] += pawn_jam[s][sq];

                    //*fork
                    //if(!enprise[xside]){
                        d = control[sq];
                        if(d & mask[s]){ // attacked & ~attack_mask[PAWN][s^1]
                            enprise[s]=1;
                            if(d & mask[s^1]); // defended
                            else{
                                up_attack[s]++;
                                if(1 > largest[s]) largest[s] = 1;
								else if(1 > smallest[s]) smallest[s] = 1;
                            }
                        }
                    //}    
                    //*/
                break;
                }
            }
        }while(++i < 16);
        
        liability[s] += queen_out * undeveloped[s] * premature_queen;
        liability[s] += undeveloped[s] * unmoved_piece;
    }while((s ^= 1) != xside);
    
	//note: crafty does not penalize bishop pairs for pawn 'obstacles' but awards only 30
	// also, he doesnt bother with pawns of other color ?? ah ha!
	// because for the most part, this term is trying to keep bishop from getting hemmed in by own pawns
	// side[s] with bishop[s] is penalized for ALL pawns on same color square
	t = bishcolor[WHITE][WHITE] * (pawncolor[WHITE][WHITE]);//+pawncolor[BLACK][WHITE]);
	t += bishcolor[WHITE][BLACK] * (pawncolor[WHITE][BLACK]);//+pawncolor[BLACK][BLACK]);
	liability[WHITE] += t;
	//cout << "white obs: " << t << endl;
	
	t = bishcolor[BLACK][WHITE] * (pawncolor[BLACK][WHITE]);
	t += bishcolor[BLACK][BLACK] * (pawncolor[BLACK][BLACK]);
	liability[BLACK] += t;
	//cout << "black obs: " << t << endl;
	
	/*
        prevent quies() fail high stand-pat while
        unresolved issues remain and augment score with the same when
        caps exhausted
        note: sometimes a piece is 'xray' protected even 'through' attacker
		
		xside just moved. it is side's turn.
		side has a piece hung which at the least is saved by a pin or otherwise
		prevented from capture - but probably needs to be protected or moved
		and at the worst, is double attacked and the smaller of the two is lost

		enprise[xside]==0 &&  <---- makes it wait until caps exhausted
	*/
    //*
    if(up_attack[side]){  // but has piece enprise
        if(up_attack[side]>1){
            liability[side] += forked_piece * smallest[side]; // forked! we lose smaller
            //flags;
        }// how do you know your not 'wanting' to move the piece enprise?    
        else liability[side] += hanging_piece + largest[side];//     
    }
    //*/
    // Q: let qsearch resolve these OR, cut it short quicker?
	// NB: if using futility prunning, this code cant 'prevent
    /*
    if(up_attack[xside]){  // but has piece enprise
        if(up_attack[xside]>1){
            liability[xside] += forked_piece * smallest[xside]; // forked! we lose smaller
            //flags;
        }    
        else liability[xside] += hanging_piece + largest[xside];    
    }
    //*/
    
}
                        
